27. Remove Element


Given an array and a value, remove all instances of that value in-place and return the new length.

Do not allocate extra space for another array, you must do this by modifying the input array in-place with O(1) extra memory.

The order of elements can be changed. It doesn't matter what you leave beyond the new length.

Example:

Given nums = [3,2,2,3], val = 3,

Your function should return length = 2, with the first two elements of nums being 2.


Summary

This is a pretty easy problem, but one may get confused by the term "in-place" and thought it is impossible to remove an element from the array without making a copy of the array.

Hints

  1. Try two pointers.
  2. Did you use the property of "the order of elements can be changed"?
  3. What happens when the elements to remove are rare?

Solution


Approach #1 (Two Pointers) [Accepted]

Intuition

Since question asked us to remove all elements of the given value in-place, we have to handle it with extra space. How to solve it? We can keep two pointers and , where is the slow-runner while is the fast-runner.

Algorithm

When equals to the given value, skip this element by incrementing . As long as , we copy to and increment both indexes at the same time. Repeat the process until reaches the end of the array and the new length is .

This solution is very similar to the solution to Remove Duplicates from Sorted Array.

public int removeElement(int[] nums, int val) {
    int i = 0;
    for (int j = 0; j < nums.length; j++) {
        if (nums[j] != val) {
            nums[i] = nums[j];
            i++;
        }
    }
    return i;
}

Complexity analysis

  • Time complexity : . Assume the array has a total of elements, both and traverse at most steps.

  • Space complexity : .


Approach #2 (Two Pointers - when elements to remove are rare) [Accepted]

Intuition

Now consider cases where the array contains few elements to remove. For example, . The previous algorithm will do unnecessary copy operation of the first four elements. Another example is . It seems unnecessary to move elements one step left as the problem description mentions that the order of elements could be changed.

Algorithm

When we encounter , we can swap the current element out with the last element and dispose the last one. This essentially reduces the array's size by 1.

Note that the last element that was swapped in could be the value you want to remove itself. But don't worry, in the next iteration we will still check this element.

public int removeElement(int[] nums, int val) {
    int i = 0;
    int n = nums.length;
    while (i < n) {
        if (nums[i] == val) {
            nums[i] = nums[n - 1];
            // reduce array size by one
            n--;
        } else {
            i++;
        }
    }
    return n;
}

Complexity analysis

  • Time complexity : . Both and traverse at most steps. In this approach, the number of assignment operation is equal to the number of elements to remove. So it is more efficient if elements to remove are rare.

  • Space complexity : .

Analysis written by @feelxia, revised by @1337c0d3r.